## de.srlabs.snoopsnitch_40_src.tar.gz

=== analysis/catcher/Makefile ===
DB ?= ~/MSD/Traces/gsmmap_19112014.sqlite

COMMON_GP = \
		unset key; \
		set datafile separator "|"; \
        set terminal pdf; \
        set output "$@"; \
		set grid ytics lc rgb "grey" lw 1 lt 0; \
		set grid xtics lc rgb "grey" lw 1 lt 0; \
		set title "$(PREFIX)";

CIPHER_SQL = \
        DROP view IF EXISTS cs; \
        CREATE VIEW cs AS \
        SELECT count(*) AS count FROM session_info \
        WHERE cipher > 0 AND rat = 0 AND cipher_delta > 0 AND cipher_delta < 10000000; \
        SELECT cipher_delta, (count(*)+0.0)/cs.count AS ratio, cipher \
		FROM session_info, cs \
        WHERE cipher > 0 AND rat = 0 AND cipher_delta > 0 AND cipher_delta < 10000000 \
        GROUP BY cipher_delta \
		HAVING ratio > 0.001 \
        ORDER BY cipher_delta \
		;

AUTH_SQL = \
        DROP view IF EXISTS au; \
        CREATE VIEW au AS \
        SELECT count(*) AS count FROM session_info \
        WHERE auth > 0 AND rat = 0 AND auth_delta > 0; \
        SELECT auth_delta, (count(*)+0.0)/au.count AS ratio, auth FROM session_info, au \
        WHERE auth > 0 AND rat = 0 AND auth_delta > 0 \
        GROUP BY auth_delta \
		HAVING ratio > 0.001 \
        ORDER BY auth_delta \
		;

IMEISV_SQL = \
        DROP VIEW IF EXISTS imeisv; \
        CREATE VIEW imeisv AS \
        SELECT count(*) as count, round(sum(CASE WHEN cmc_imeisv > 0 THEN 1.0 ELSE 0.0 END)/count(*),1) as no_imeisv \
        FROM session_info \
        WHERE rat = 0 AND cipher > 0 AND mcc > 0 \
        GROUP BY mcc, mnc \
        HAVING count > 20; \
        DROP VIEW IF EXISTS tot; \
        CREATE VIEW tot AS select count(*) as count FROM imeisv; \
        SELECT no_imeisv, (count(*)+0.0)/tot.count as ratio \
		FROM imeisv, tot \
		GROUP by no_imeisv \
		;

DURATION_SQL = \
		DROP VIEW IF EXISTS dcount; \
		CREATE VIEW dcount AS SELECT count(*) as d from session_info WHERE duration > 350; \
		SELECT duration/500 AS seconds, (count(*)+0.0)/dcount.d AS ratio, sum(CASE WHEN t_locupd THEN 1.0 ELSE 0.0 END)/dcount.d as locupd \
		FROM session_info, dcount \
		WHERE duration > 350 \
		GROUP BY duration/500 \
		HAVING ratio > 0.001;

REJECT_SQL = \
		SELECT ifnull(causes.text || ' \(' || si.lu_rej_cause || '\)', 'Cause value ' || si.lu_rej_cause) as cause, \
			count(*) AS count, \
			si.lu_rej_cause \
		FROM session_info as si LEFT JOIN causes \
		ON si.lu_rej_cause = causes.cause \
		WHERE t_locupd AND not lu_acc AND lu_rej_cause > 0 \
		GROUP BY lu_rej_cause \
		ORDER BY count DESC;

LU_TYPE_SQL = \
		SELECT \
			lu_type, \
			sum(CASE WHEN not lu_acc THEN 0 ELSE 1 END) as acc_count, \
			sum(CASE WHEN not lu_acc THEN 1 ELSE 0 END) as rej_count \
		FROM session_info \
		WHERE t_locupd AND lu_type < 3 \
		GROUP BY lu_type \
		ORDER BY acc_count + rej_count DESC;

PGROUPS_SQL = \
		DROP VIEW IF EXISTS gcount; \
		CREATE VIEW gcount AS SELECT count(*) as g FROM cell_info WHERE cid > 0; \
		SELECT \
			(count(*)+0.0)/gcount.g AS perc, \
			((9.0 - cell_info.agch_blocks - 6 * cell_info.combined) * cell_info.pag_mframes) AS groups \
		FROM cell_info, gcount \
			WHERE \
			cid >0 \
		GROUP BY \
			groups \
		ORDER BY \
			groups;

PAGING_RATE_SQL = \
		DROP VIEW IF EXISTS pcount; \
		CREATE VIEW pcount AS SELECT count(*) as p FROM paging_info; \
		SELECT \
			(count(*)+0.0)/pcount.p AS perc, \
			round(pag1_rate, 1) as p1 \
		FROM paging_info, pcount \
		GROUP BY \
			p1 \
		ORDER BY \
			p1;

PAGING_TIMELINE_SQL = \
		SELECT \
			strftime('%Y-%m-%d,%H:%M:%S', timestamp) as time, pag1_rate \
		FROM paging_info \
		WHERE timestamp != (SELECT MAX(timestamp) FROM paging_info) \
		ORDER BY \
			strftime('%s',timestamp);

# FIXME: This does not account for the case where SI5ter is present.
NEIGHBORS_SQL = \
	SELECT count(*), ncount \
	FROM \
		(SELECT count(*) AS ncount FROM arfcn_list WHERE source = 'SI5' GROUP BY id) \
	GROUP BY \
		ncount;

T3212_SQL = \
	DROP VIEW IF EXISTS c; \
	CREATE VIEW c AS SELECT count(*) as count FROM cell_info WHERE si3; \
	SELECT (count(*)+0.0)/c.count, t3212 \
	FROM cell_info, c \
	WHERE si3 \
	GROUP BY t3212;

CRO_SQL = \
	DROP VIEW IF EXISTS c; \
	CREATE VIEW c AS SELECT count(*) as count from cell_info WHERE si4 and cro > 0; \
	SELECT ((count(*)+0.0)/c.count) as perc, cro \
	FROM cell_info, c \
	WHERE si4 and cro > 0 \
	GROUP BY cro \
	ORDER BY cro;

PAGING_GROUPS_SQL = \
	DROP VIEW IF EXISTS c; \
	CREATE VIEW c AS SELECT count(*) as count from cell_info WHERE si3; \
	SELECT (count(*)+0.0)/c.count as perc, (9 - agch_blocks - 6 * combined) * (pag_mframes + 2) AS pgroups \
	FROM cell_info, c \
	WHERE si3 \
	GROUP BY pgroups;

ORPHANED_TIME_SQL = \
	SELECT count(*), round(duration/100)/10 \
	FROM session_info \
	WHERE \
		(assign_cmpl OR mobile_term) AND \
		NOT auth AND \
		NOT cipher > 0 AND \
		NOT sms_presence AND \
		NOT call_presence AND \
		t_release \
	GROUP BY round(duration/100);

TESTS = \
	test-II-3_3_2 \
	test-II-3_7_1 \
	test-II-3_7_2 \
	test-III-3_1 \
	test-IV-3_10_1 \
	test-IV-3_10_2 \
	test-III-3_11 \
	test-III-3_2 \
	test-III-3_3_1 \

all: ../prebuilt/catcher_analysis.sql ../prebuilt/catcher_analysis_si.sql

base_charts: \
	$(PREFIX)_duration.pdf \
	$(PREFIX)_orphaned_time.pdf \
	$(PREFIX)_lu_reject.pdf

catcher: \
	$(PREFIX)_catcher.log

cell_charts: \
	$(PREFIX)_cro.pdf \
	$(PREFIX)_t3212.pdf \

neighbors: \
	$(PREFIX)_neighbors.pdf \

# Charts for paging statistics
paging_charts: paging_groups \
	$(PREFIX)_paging_timeline.pdf \
	$(PREFIX)_paging_rate.pdf

paging_groups: \
	$(PREFIX)_paging_groups.pdf \

# Only valid when ciphering was used
cipher_charts: \
	$(PREFIX)_auth_times.pdf \
	$(PREFIX)_cipher_times.pdf \
	$(PREFIX)_imeisv_rate.pdf

validate: \
	$(TESTS) \
	validate_vodafone \
	validate_eplus \
	validate_o2 \
	validate_telekom \
	validate_gsmmap \
	validate_xgold

validate_gsmmap:
	@$(MAKE) PREFIX=GSMMap base_charts cipher_charts

validate_xgold:
	@$(MAKE) DB=~/MSD/Traces/reparsed_xgold.sqlite PREFIX=X-GOLD paging_groups cell_charts

validate_vodafone:
	@$(MAKE) PREFIX=Vodafone DB=$(PWD)/../doc/validate-Vodafone-B_DD-20141118/db.sqlite paging_charts catcher cell_charts neighbors

validate_eplus:
	@$(MAKE) PREFIX=E-Plus DB=$(PWD)/../doc/validate-EPlus-DD_B-20141117/db.sqlite paging_charts catcher cell_charts neighbors

validate_o2:
	@$(MAKE) PREFIX=O2 DB=$(PWD)/../doc/validate-O2-B_DD-20141117/db.sqlite paging_charts catcher cell_charts neighbors

validate_telekom:
	@$(MAKE) PREFIX=Telekom DB=$(PWD)/../doc/validate-Telekom-DD_B-20141118/db.sqlite paging_charts catcher cell_charts

# Full validation (all graphs, catcher metrics log)
# Todo: security metrics
$(TESTS):
	@$(MAKE) PREFIX=$@ DB=$(PWD)/../doc/$@/db.sqlite catcher cell_charts paging_charts

../prebuilt/catcher_analysis.sql: analysis.sql analysis_ci.sql analysis_si.sql sql/*.sql scripts/resolve_read.pl
	@./scripts/resolve_read.pl $< > $@.tmp
# The current function for reading SQL files in the app misbehaves
# when comments contain a semicolon. This results in a statement
# containing only comments being passed to SQLite which causes an
# exception
	@grep -e '--.*;' $@.tmp; test $$? -eq 1
	@mv $@.tmp $@

../prebuilt/catcher_analysis_si.sql: analysis_si.sql sql/*.sql scripts/resolve_read.pl
	@./scripts/resolve_read.pl $< > $@.tmp
	@mv $@.tmp $@

$(PREFIX)_catcher.log: validate.sql
	@echo [CATCHER] $@.
	@test -f $(DB)
	@cp $(DB) tmp.sqlite
	@echo "$(PREFIX)" > $@.tmp
	@sqlite3 tmp.sqlite < $< > $@.tmp
	@rm -f tmp.sqlite
	@mv $@.tmp $@

$(PREFIX)_cipher_times.dat: SQL     = $(CIPHER_SQL)
$(PREFIX)_cipher_times.pdf: GNUPLOT = set xlabel "Cipher delay [ms]"; \
	plot "$<" using 1:2 with lines;

$(PREFIX)_auth_times.dat:   SQL     = $(AUTH_SQL)
$(PREFIX)_auth_times.pdf:   GNUPLOT = set xlabel "Authentication delay [ms]"; \
	plot "$<" using 1:2 with lines;

$(PREFIX)_imeisv_rate.dat:  SQL     = $(IMEISV_SQL)
$(PREFIX)_imeisv_rate.pdf:  GNUPLOT = set xlabel "Fraction of IMEISV requests in CIPHER MODE COMMAND"; \
	plot "$<" using 1:2 with lines;

$(PREFIX)_duration.dat: SQL     = $(DURATION_SQL)
$(PREFIX)_duration.pdf: GNUPLOT = set xlabel "Session duration [s]"; \
	set key; \
	plot "$<" using 1:2 with lines title "Total", \
	"$<" using 1:3 with lines title "Location updates";

$(PREFIX)_lu_reject.dat: SQL	  = $(REJECT_SQL)
$(PREFIX)_lu_reject.pdf: GNUPLOT = set xlabel "Reject causes"; \
	unset grid; \
	set format y "%1.0f"; \
	set style fill solid border -1; \
	set xtics rotate by -45; \
	set style data histograms; \
	plot "$<" using 2:xtic(1) title col, \
	"" using ($$0-1.0):($$2+2.5):2 with labels;

$(PREFIX)_lu_type.dat: SQL	  = $(LU_TYPE_SQL)
$(PREFIX)_lu_type.pdf: GNUPLOT = set xlabel "Location update types"; \
	set key; \
	unset grid; \
	set style data histograms; \
	set format y "%1.0f"; \
	set style fill solid border -1; \
	set xtics rotate by -45; \
	plot "$<" using 3:xtic(1) title "Rejected", \
	"" using 2:xtic(1) title "Accepted"\

$(PREFIX)_pgroups.dat: SQL     = $(PGROUPS_SQL)
$(PREFIX)_pgroups.pdf: GNUPLOT = set xlabel "Number of paging groups"; \
	set style fill solid; \
	set boxwidth 0.5; \
	plot "$<" using 2:1 with boxes;

$(PREFIX)_paging_rate.dat: SQL     = $(PAGING_RATE_SQL)
$(PREFIX)_paging_rate.pdf: GNUPLOT = set xlabel "Number of type-1 paging requests per second"; \
	plot "$<" using 2:1 with lines;

$(PREFIX)_paging_timeline.dat: SQL     = $(PAGING_TIMELINE_SQL)
$(PREFIX)_paging_timeline.pdf: GNUPLOT = set xlabel "Paging request frequency over time"; \
	set xdata time; \
	set timefmt "%Y-%m-%d,%H:%M:%S"; \
	plot "$<" using 1:2 index 0 with lines;

$(PREFIX)_neighbors.dat: SQL     = $(NEIGHBORS_SQL)
$(PREFIX)_neighbors.pdf: GNUPLOT = set xlabel "Number of neighbor cells announced in SI5"; \
	set boxwidth 1; \
	set style fill solid border -1; \
	plot "$<" using 2:1 with boxes;

$(PREFIX)_t3212.dat: SQL     = $(T3212_SQL)
$(PREFIX)_t3212.pdf: GNUPLOT = set xlabel "Cell reselect timeout"; \
	unset grid; \
	set boxwidth 3; \
	set style fill solid border -1; \
	set format x "%1.0f"; \
	plot "$<" using 2:1 with boxes;

$(PREFIX)_cro.dat: SQL     = $(CRO_SQL)
$(PREFIX)_cro.pdf: GNUPLOT = set xlabel "Cell reselect offset"; \
	unset key; \
	unset grid; \
	set format x "%1.0f"; \
	set style data histograms; \
	set style fill solid border -1; \
	plot "$<" using 1:xtic(2) title "CRO"

$(PREFIX)_paging_groups.dat: SQL     = $(PAGING_GROUPS_SQL)
$(PREFIX)_paging_groups.pdf: GNUPLOT = set xlabel "No. of paging groups"; \
	unset key; \
	unset grid; \
	set format x "%1.0f"; \
	set style data histograms; \
	set style fill solid border -1; \
	plot "$<" using 1:xtic(2) title "paging groups"

$(PREFIX)_orphaned_time.dat: SQL     = $(ORPHANED_TIME_SQL)
$(PREFIX)_orphaned_time.pdf: GNUPLOT = set xlabel "Time traffic channel remained unused [s]"; \
	set boxwidth 0.1; \
	set style fill solid; \
	plot "$<" using 2:1 with boxes;

%.dat: Makefile
	@echo [SQL] $@.
	@test "x$(SQL)" != "x"
	@test -f $(DB)
	@cp $(DB) tmp.sqlite
	@sqlite3 -header tmp.sqlite -separator '|' "$(SQL)" > $@.tmp
	@rm -f tmp.sqlite
	@mv $@.tmp $@

%.pdf: %.dat Makefile
	@echo [GPL] $@.
	@gnuplot -e '$(COMMON_GP)$(GNUPLOT)'
	@rm -f $<

clean:
	rm -f *.pdf *.tmp *.dat *catcher.log

.PHONY: clean $(TESTS)

=== contrib/gsm-parser/CMakeLists.txt ===
cmake_minimum_required(VERSION 2.8.7 FATAL_ERROR)

set(CPACK_PACKAGE_NAME "metagsm")
set(CPACK_PACKAGE_VENDOR "Security Research Labs")
set(CPACK_PACKAGE_DESCRIPTION_SUMMARY "GSM/3G/LTE parser")
set(CPACK_PACKAGE_VERSION "0.1.0")
set(CPACK_PACKAGE_VERSION_MAJOR "0")
set(CPACK_PACKAGE_VERSION_MINOR "1")

# -----------------------------------------------------------------------------
# Make RelWithDebInfo the default build type if otherwise not set
# -----------------------------------------------------------------------------
set(build_types Debug Release RelWithDebInfo MinSizeRel)
if(NOT CMAKE_BUILD_TYPE)
	message(STATUS "You can choose the type of build, options are:${build_types}")
	set(CMAKE_BUILD_TYPE RelWithDebInfo CACHE String
		"Options are ${build_types}"
		FORCE
	)

	# Provide drop down menu options in cmake-gui
	set_property(CACHE CMAKE_BUILD_TYPE PROPERTY STRINGS ${build_types})
endif()
message(STATUS "Doing a ${CMAKE_BUILD_TYPE} build")

# -----------------------------------------------------------------------------
# Option to enable/disable assertions
# -----------------------------------------------------------------------------

# Filter out definition of NDEBUG from the default build configuration flags.
# We will add this ourselves if we want to disable assertions
foreach (build_config ${build_types})
	string(TOUPPER ${build_config} upper_case_build_config)
	foreach (language CXX C)
		set(VAR_TO_MODIFY "CMAKE_${language}_FLAGS_${upper_case_build_config}")
		string(REGEX REPLACE "(^| )[/-]D *NDEBUG($| )"
							 " "
							 replacement
							 "${${VAR_TO_MODIFY}}"
			  )
		#message("Original (${VAR_TO_MODIFY}) is ${${VAR_TO_MODIFY}} replacement is ${replacement}")
		set(${VAR_TO_MODIFY} "${replacement}" CACHE STRING "Default flags for ${build_config} configuration" FORCE)
	endforeach()
endforeach()

project (metagsm)

option(ENABLE_ASSERTIONS "Build with assertions enabled" ON)
if (ENABLE_ASSERTIONS)
	# NDEBUG was already removed.
else()
	# Note this definition doesn't appear in the cache variables.
	add_definitions(-DNDEBUG)
endif()

SET(CMAKE_MODULE_PATH ${PROJECT_SOURCE_DIR}/cmake) #m4-extra contains some library search cmake stuff

macro(add_c_flag flagname)
	set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} ${flagname}")
endmacro()

set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -ggdb")
SET(CMAKE_C_FLAGS_RELWITHDEBINFO "-ggdb -O3")
SET(CMAKE_C_FLAGS_RELEASE "-O3 -g0 -DNDEBUG")
SET(CMAKE_C_FLAGS_DEBUG "-O0 -ggdb")

include(CheckCCompilerFlag)
macro(add_c_flag_if_supported flagname)
	check_c_compiler_flag("${flagname}" HAVE_FLAG_${flagname})
	if(HAVE_FLAG_${flagname})
		set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} ${flagname}")
		message(STATUS "flag ${flagname} supported")
	else()
		message(STATUS "flag ${flagname} NOT supported")
	endif()
endmacro()

macro(add_c_flag flagname)
    set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} ${flagname}")
endmacro()

#add_c_flag("-std=c99")
add_c_flag_if_supported("-Wall")
add_c_flag_if_supported("-Wextra")
add_c_flag_if_supported("-Wunused")
#add_c_flag_if_supported("-pedantic")
add_c_flag_if_supported("-Wsign-compare")
add_c_flag_if_supported("-fno-omit-frame-pointer")
add_c_flag_if_supported("-Wtype-limits")
add_c_flag_if_supported("-Wuninitialized")
add_c_flag_if_supported("-Wno-deprecated")
add_c_flag_if_supported("-Wstrict-aliasing")
add_c_flag_if_supported("-Wpointer-arith")
add_c_flag_if_supported("-Wheader-guard")

find_package(MySQL)
IF (MYSQL_FOUND)
	MESSAGE(STATUS "OK, Found MySQL!")
	include_directories(${MYSQL_INCLUDE_DIR}/mysql)
	link_directories(${MYSQL_LIB_DIR})
	add_definitions( -DUSE_MYSQL )
else ()
	MESSAGE(STATUS "WARNING: Did not find MySQL, MySQL support will be disabled")
endif()

find_package(Sqlite3)
IF (SQLITE3_FOUND)
	MESSAGE(STATUS "OK, Found Sqlite3!")
	include_directories(${SQLITE3_INCLUDE_DIR})
	add_definitions( -DUSE_SQLITE )
else ()
	MESSAGE(STATUS "WARNING: Did not find Sqlite3, Sqlite3 support will be disabled")
endif ()

find_package(libasn1c REQUIRED)
include_directories(${LIBASN1C_INCLUDE_DIRS})

find_package(libosmoasn1rrc REQUIRED)
include_directories(${LIBOSMO_ASN1_RRC_INCLUDE_DIR})

find_package(libosmocore REQUIRED)
include_directories(${LIBOSMOCORE_INCLUDE_DIR})

find_package(PCAP REQUIRED)
include_directories(${PCAP_INCLUDE_DIR})

macro(metagsm_add_public_header LIBTARGET HEADER)
	set(HEADER_PATH "${CMAKE_CURRENT_SOURCE_DIR}/${HEADER}")
	if(EXISTS "${HEADER_PATH}")
		# Get existing PUBLIC_HEADER
		get_target_property(EXISTING_PUBLIC_HEADERS ${LIBTARGET} PUBLIC_HEADER)
		if(EXISTING_PUBLIC_HEADERS)
			list(APPEND EXISTING_PUBLIC_HEADERS "${HEADER_PATH}")
		else()
			# Do not append to empty list
			set(EXISTING_PUBLIC_HEADERS "${HEADER_PATH}")
		endif()
		set_target_properties(${LIBTARGET}
							  PROPERTIES
							  PUBLIC_HEADER "${EXISTING_PUBLIC_HEADERS}"
							 )
	else()
		message(FATAL_ERROR "Cannot add public header, file ${HEADER_PATH} does not exist.")
	endif()
endmacro()

# -----------------------------------------------------------------------------
# Provide an export name to be used by targets that wish to export themselves.
# -----------------------------------------------------------------------------
set(METAGSM_EXPORT_NAME "MetaGSMTargets")


set(metagsm_lib_files
	address.c assignment.c bit_func.c ccch.c cch.c chan_detect.c crc.c
	umts_rrc.c diag_input.c gprs.c gsm_interleave.c cell_info.c
	l3_handler.c output.c process.c punct.c rand_check.c rlcmac.c
	sch.c session.c sms.c tch.c viterbi.c
)

set(my_link_libs "")

IF (MYSQL_FOUND)
	set(metagsm_lib_files ${metagsm_lib_files} mysql_api.c)
	SET(my_link_libs ${my_link_libs} ${MYSQL_LIB})
	message(STATUS "heee mysql")
ENDIF()

IF (SQLITE3_FOUND)
	set(metagsm_lib_files ${metagsm_lib_files} sqlite_api.c)
	SET(my_link_libs ${my_link_libs} ${SQLITE3_LIBRARIES})
	message(STATUS "heee sqlite")
ENDIF()

add_library(libmetagsm SHARED ${metagsm_lib_files})

target_link_libraries(libmetagsm
	${my_link_libs}
	${LIBASN1C_LIBRARIES}
	${LIBOSMO_ASN1_RRC_LIBRARY}
	${LIBOSMOCORE_LIBRARIES}
	${PCAP_LIBRARY}
)

set_target_properties(libmetagsm PROPERTIES
	OUTPUT_NAME metagsm
	PUBLIC_HEADER "${metagsm_public_headers}"
)

metagsm_add_public_header(libmetagsm address.h)
metagsm_add_public_header(libmetagsm ccch.h)
metagsm_add_public_header(libmetagsm crc.h)
metagsm_add_public_header(libmetagsm gsm_interleave.h)
metagsm_add_public_header(libmetagsm process.h)
metagsm_add_public_header(libmetagsm sch.h)
metagsm_add_public_header(libmetagsm umts_rrc.h)
metagsm_add_public_header(libmetagsm assignment.h)
metagsm_add_public_header(libmetagsm cch.h)
metagsm_add_public_header(libmetagsm diag_input.h)
metagsm_add_public_header(libmetagsm l3_handler.h)
metagsm_add_public_header(libmetagsm punct.h)
metagsm_add_public_header(libmetagsm session.h)
metagsm_add_public_header(libmetagsm viterbi.h)
metagsm_add_public_header(libmetagsm bit_func.h)
metagsm_add_public_header(libmetagsm cell_info.h)
metagsm_add_public_header(libmetagsm diag_structs.h)
metagsm_add_public_header(libmetagsm mysql_api.h)
metagsm_add_public_header(libmetagsm rand_check.h)
metagsm_add_public_header(libmetagsm sms.h)
metagsm_add_public_header(libmetagsm burst_desc.h)
metagsm_add_public_header(libmetagsm rlcmac.h)
metagsm_add_public_header(libmetagsm chan_detect.h)
metagsm_add_public_header(libmetagsm gprs.h)
metagsm_add_public_header(libmetagsm output.h)
metagsm_add_public_header(libmetagsm sqlite_api.h)

set(HEADER_DEST "${CMAKE_BINARY_DIR}/include/metagsm")
add_custom_target(CopyPublicHeaders ALL)
get_target_property(metagsm_public_headers libmetagsm PUBLIC_HEADER)
foreach(public_header ${metagsm_public_headers})
	get_filename_component(HEADER_NAME ${public_header} NAME)
	add_custom_command(TARGET CopyPublicHeaders PRE_BUILD
					   COMMAND ${CMAKE_COMMAND} -E make_directory
							   "${HEADER_DEST}"
					   COMMAND ${CMAKE_COMMAND} -E echo
					   "Copying ${HEADER_NAME} to ${HEADER_DEST}"
					   COMMAND ${CMAKE_COMMAND} -E
						   copy_if_different
						   ${public_header}
						   "${HEADER_DEST}"
					  )
endforeach()

install(TARGETS libmetagsm
	EXPORT ${METAGSM_EXPORT_NAME}
	LIBRARY DESTINATION "${CMAKE_INSTALL_PREFIX}/lib"
	ARCHIVE DESTINATION "${CMAKE_INSTALL_PREFIX}/lib"
	PUBLIC_HEADER DESTINATION "${CMAKE_INSTALL_PREFIX}/include/metagsm"
)

set(CPACK_PACKAGE_EXECUTABLES "")

############

add_executable (diag_import
	diag_import.c
)

set_target_properties(diag_import PROPERTIES RUNTIME_OUTPUT_DIRECTORY ${PROJECT_BINARY_DIR})
set_target_properties(diag_import PROPERTIES INSTALL_RPATH_USE_LINK_PATH TRUE)
target_link_libraries(diag_import
	libmetagsm
)

install(TARGETS diag_import
	EXPORT ${METAGSM_EXPORT_NAME}
	RUNTIME DESTINATION bin
)
SET(CPACK_PACKAGE_EXECUTABLES ${CPACK_PACKAGE_EXECUTABLES} "diag_import")

############

add_executable (hex_import
	hex_import.c
)

set_target_properties(hex_import PROPERTIES RUNTIME_OUTPUT_DIRECTORY ${PROJECT_BINARY_DIR})
set_target_properties(hex_import PROPERTIES INSTALL_RPATH_USE_LINK_PATH TRUE)
target_link_libraries(hex_import
	libmetagsm
)

install(TARGETS hex_import
	EXPORT ${METAGSM_EXPORT_NAME}
	RUNTIME DESTINATION bin
)
SET(CPACK_PACKAGE_EXECUTABLES ${CPACK_PACKAGE_EXECUTABLES} "hex_import")

############

add_executable (gsmtap_import
	gsmtap_import.c
)

set_target_properties(gsmtap_import PROPERTIES RUNTIME_OUTPUT_DIRECTORY ${PROJECT_BINARY_DIR})
set_target_properties(gsmtap_import PROPERTIES INSTALL_RPATH_USE_LINK_PATH TRUE)
target_link_libraries(gsmtap_import
	libmetagsm
)

install(TARGETS gsmtap_import
	EXPORT ${METAGSM_EXPORT_NAME}
	RUNTIME DESTINATION bin
)
SET(CPACK_PACKAGE_EXECUTABLES ${CPACK_PACKAGE_EXECUTABLES} "gsmtap_import")

############

if (MYSQL_FOUND)
	add_executable (db_import
		db_import.c
	)

	set_target_properties(db_import PROPERTIES RUNTIME_OUTPUT_DIRECTORY ${PROJECT_BINARY_DIR})
	set_target_properties(db_import PROPERTIES INSTALL_RPATH_USE_LINK_PATH TRUE)
	target_link_libraries(db_import
		libmetagsm
	)

	install(TARGETS db_import
		EXPORT ${METAGSM_EXPORT_NAME}
		RUNTIME DESTINATION bin
	)
	SET(CPACK_PACKAGE_EXECUTABLES ${CPACK_PACKAGE_EXECUTABLES} "db_import")
endif()


# -----------------------------------------------------------------------------
# Add uninstall target for makefiles
# -----------------------------------------------------------------------------
configure_file(
    "${CMAKE_CURRENT_SOURCE_DIR}/cmake/cmake_uninstall.cmake.in"
    "${CMAKE_CURRENT_BINARY_DIR}/cmake_uninstall.cmake"
    IMMEDIATE @ONLY
)

add_custom_target(uninstall
    COMMAND ${CMAKE_COMMAND} -P ${CMAKE_CURRENT_BINARY_DIR}/cmake_uninstall.cmake
)

=== contrib/gsm-parser/Makefile ===
PREFIX ?= /usr

CFLAGS  = \
	-Wall \
	-ggdb \
	-fPIC \
	-I. \
	-I$(PREFIX)/include \
	-I$(PREFIX)/include/asn1c

LDFLAGS = \
	-L$(PREFIX)/lib \
	-losmocore \
	-losmogsm \
	-lasn1c \
	-lm \
	-losmo-asn1-rrc

OBJ = \
	address.o \
	assignment.o \
	bit_func.o \
	ccch.o \
	cch.o \
	chan_detect.o \
	crc.o \
	umts_rrc.o \
	diag_input.o \
	gprs.o \
	gsm_interleave.o \
	cell_info.o \
	l3_handler.o \
	output.o \
	process.o \
	punct.o \
	rand_check.o \
	rlcmac.o \
	sch.o \
	session.o \
	sms.o \
	tch.o \
	viterbi.o \
	lte_nas_eps.o \
	lte_nas_eps_mm.o \
	lte_nas_eps_sm.o \
	lte_nas_eps_info.o

TOOLS = diag_import

ifeq ($(TARGET),host)

CC       = gcc
AR       = ar
TOOLS   += hex_import gsmtap_import analyze.sh
CFLAGS  += -O3

else ifeq ($(TARGET),android)

CC      = $(CROSS_COMPILE)-gcc
AR      = $(CROSS_COMPILE)-ar

CFLAGS += \
	-O2 \
	-fPIE \
	-nostdlib \
	--sysroot=$(SYSROOT) \
	-DUSE_AUTOTIME=1 \
	-DMSG_VERBOSE=1 \
	-DRATE_LIMIT=1 \

LDFLAGS += \
	-fPIE \
	-pie \
	-lcompat \
	--sysroot $(SYSROOT) \
	-L.

LIBRARIES += \
	libcompat.so
else 

ifneq ($(MAKECMDGOALS),clean)
$(error Unsupported target: $(TARGET))
endif
endif

ifeq ($(MYSQL),1)

ifneq ($(TARGET),host)
$(error MYSQL supported for host builds only)
endif

CFLAGS  += -DUSE_MYSQL $(shell mysql_config --cflags)
LDFLAGS += $(shell mysql_config --libs)
OBJ     += mysql_api.o
TOOLS   += db_import
endif

ifeq ($(SQLITE),1)

ifneq ($(TARGET),host)
$(error SQLITE supported for host builds only)
endif

CFLAGS  += -DUSE_SQLITE
LDFLAGS += -lsqlite3
OBJ     += sqlite_api.o
endif

ifeq ($(PCAP),1)
CFLAGS  += -DUSE_PCAP
endif

CFLAGS  += $(EXTRA_CFLAGS)
LDFLAGS += $(EXTRA_LDFLAGS)

%.o: %.c %.h
	$(CC) -c -o $@ $< $(CFLAGS)

%.o: %.c
	$(CC) -c -o $@ $< $(CFLAGS)

all: $(TOOLS)

install: $(TOOLS) $(LIBRARIES) sm_2g.sql sm_3g.sql doc/data/mcc.sql doc/data/mnc.sql doc/data/hlr_info.sql doc/sm.sql
	install -d $(DESTDIR)
	install $^ $(DESTDIR)

sm_2g.sql: doc/sm_2.4.sql
	cpp -DSQLITE -w $< | grep -ve "^#" > $@.tmp
	mv $@.tmp $@

sm_3g.sql: doc/sm_3G_0.9.sql
	cpp -DSQLITE -w $< | grep -ve "^#" > $@.tmp
	mv $@.tmp $@

libmetagsm.so: $(OBJ)
	$(CC) -o $@ $^ -shared -fPIC $(LDFLAGS)

# Use $EXTRA_LDFLAGS here since $LDFLAGS already contains libcompat.so
libcompat.so: compat.o
	$(CC) -o $@ $^ -shared -fPIC --sysroot $(SYSROOT) $(EXTRA_LDFLAGS) -lc

libmetagsm.a: $(OBJ)
	$(AR) rcs $@ $^

hex_import: hex_import.o libmetagsm.a
	$(CC) -o $@ $^ $(LDFLAGS)

diag_import: diag_import.o libmetagsm.a $(LIBRARIES)
	$(CC) -o $@  diag_import.o libmetagsm.a $(LDFLAGS)

gsmtap_import: gsmtap_import.o libmetagsm.a
	$(CC) -o $@ $^ $(LDFLAGS) -lpcap

db_import: db_import.o libmetagsm.a
	$(CC) -o $@ $^ $(LDFLAGS)

analyze.sh: analyze_header.in cell_info.sql si.sql sms.sql analyze_footer.in
	cat $^ >> $@
	chmod 755 $@

clean:
	@rm -f *.o libmetagsm* *.so
	@rm -f $(TOOLS)

database:
	@rm metadata.db
	@sqlite3 metadata.db < si.sql
	@sqlite3 metadata.db < sms.sql
	@sqlite3 metadata.db < cell_info.sql

.PHONY: all clean database

=== SnoopSnitch/patchanalysis/contrib/busybox/Makefile ===
VERSION = 1
PATCHLEVEL = 27
SUBLEVEL = 0
EXTRAVERSION = .git
NAME = Unnamed

# *DOCUMENTATION*
# To see a list of typical targets execute "make help"
# More info can be located in ./README
# Comments in this file are targeted only to the developer, do not
# expect to learn how to build the kernel reading this file.

# Do not print "Entering directory ..."
MAKEFLAGS += --no-print-directory

# We are using a recursive build, so we need to do a little thinking
# to get the ordering right.
#
# Most importantly: sub-Makefiles should only ever modify files in
# their own directory. If in some directory we have a dependency on
# a file in another dir (which doesn't happen often, but it's often
# unavoidable when linking the built-in.o targets which finally
# turn into busybox), we will call a sub make in that other dir, and
# after that we are sure that everything which is in that other dir
# is now up to date.
#
# The only cases where we need to modify files which have global
# effects are thus separated out and done before the recursive
# descending is started. They are now explicitly listed as the
# prepare rule.

# To put more focus on warnings, be less verbose as default
# Use 'make V=1' to see the full commands

ifdef V
  ifeq ("$(origin V)", "command line")
    KBUILD_VERBOSE = $(V)
  endif
endif
ifndef KBUILD_VERBOSE
  KBUILD_VERBOSE = 0
endif

# Call sparse as part of compilation of C files
# Use 'make C=1' to enable sparse checking

ifdef C
  ifeq ("$(origin C)", "command line")
    KBUILD_CHECKSRC = $(C)
  endif
endif
ifndef KBUILD_CHECKSRC
  KBUILD_CHECKSRC = 0
endif

# Use make M=dir to specify directory of external module to build
# Old syntax make ... SUBDIRS=$PWD is still supported
# Setting the environment variable KBUILD_EXTMOD take precedence
ifdef SUBDIRS
  KBUILD_EXTMOD ?= $(SUBDIRS)
endif
ifdef M
  ifeq ("$(origin M)", "command line")
    KBUILD_EXTMOD := $(M)
  endif
endif


# kbuild supports saving output files in a separate directory.
# To locate output files in a separate directory two syntaxes are supported.
# In both cases the working directory must be the root of the kernel src.
# 1) O=
# Use "make O=dir/to/store/output/files/"
#
# 2) Set KBUILD_OUTPUT
# Set the environment variable KBUILD_OUTPUT to point to the directory
# where the output files shall be placed.
# export KBUILD_OUTPUT=dir/to/store/output/files/
# make
#
# The O= assignment takes precedence over the KBUILD_OUTPUT environment
# variable.


# KBUILD_SRC is set on invocation of make in OBJ directory
# KBUILD_SRC is not intended to be used by the regular user (for now)
ifeq ($(KBUILD_SRC),)

# OK, Make called in directory where kernel src resides
# Do we want to locate output files in a separate directory?
ifdef O
  ifeq ("$(origin O)", "command line")
    KBUILD_OUTPUT := $(O)
  endif
endif

# That's our default target when none is given on the command line
PHONY := _all
_all:

ifneq ($(KBUILD_OUTPUT),)
# Invoke a second make in the output directory, passing relevant variables
# check that the output directory actually exists
saved-output := $(KBUILD_OUTPUT)
KBUILD_OUTPUT := $(shell cd $(KBUILD_OUTPUT) && /bin/pwd)
$(if $(KBUILD_OUTPUT),, \
     $(error output directory "$(saved-output)" does not exist))

PHONY += $(MAKECMDGOALS)

$(filter-out _all,$(MAKECMDGOALS)) _all:
	$(if $(KBUILD_VERBOSE:1=),@)$(MAKE) -C $(KBUILD_OUTPUT) \
	KBUILD_SRC=$(CURDIR) \
	KBUILD_EXTMOD="$(KBUILD_EXTMOD)" -f $(CURDIR)/Makefile $@

# Leave processing to above invocation of make
skip-makefile := 1
endif # ifneq ($(KBUILD_OUTPUT),)
endif # ifeq ($(KBUILD_SRC),)

# We process the rest of the Makefile if this is the final invocation of make
ifeq ($(skip-makefile),)

# If building an external module we do not care about the all: rule
# but instead _all depend on modules
PHONY += all
ifeq ($(KBUILD_EXTMOD),)
_all: all
else
_all: modules
endif

srctree		:= $(if $(KBUILD_SRC),$(KBUILD_SRC),$(CURDIR))
TOPDIR		:= $(srctree)
# FIXME - TOPDIR is obsolete, use srctree/objtree
objtree		:= $(CURDIR)
src		:= $(srctree)
obj		:= $(objtree)

VPATH		:= $(srctree)$(if $(KBUILD_EXTMOD),:$(KBUILD_EXTMOD))

export srctree objtree VPATH TOPDIR


# Cross compiling and selecting different set of gcc/bin-utils
# ---------------------------------------------------------------------------
#
# When performing cross compilation for other architectures ARCH shall be set
# to the target architecture. (See arch/* for the possibilities).
# ARCH can be set during invocation of make:
# make ARCH=ia64
# Another way is to have ARCH set in the environment.
# The default ARCH is the host where make is executed.

# CROSS_COMPILE specify the prefix used for all executables used
# during compilation. Only gcc and related bin-utils executables
# are prefixed with $(CROSS_COMPILE).
# CROSS_COMPILE can be set on the command line
# make CROSS_COMPILE=ia64-linux-
# Alternatively CROSS_COMPILE can be set in the environment.
# Default value for CROSS_COMPILE is not to prefix executables
# Note: Some architectures assign CROSS_COMPILE in their arch/*/Makefile

CROSS_COMPILE ?=
# bbox: we may have CONFIG_CROSS_COMPILER_PREFIX in .config,
# and it has not been included yet... thus using an awkward syntax.
ifeq ($(CROSS_COMPILE),)
CROSS_COMPILE := $(shell grep ^CONFIG_CROSS_COMPILER_PREFIX .config 2>/dev/null)
CROSS_COMPILE := $(subst CONFIG_CROSS_COMPILER_PREFIX=,,$(CROSS_COMPILE))
CROSS_COMPILE := $(subst ",,$(CROSS_COMPILE))
#")
endif

# SUBARCH tells the usermode build what the underlying arch is.  That is set
# first, and if a usermode build is happening, the "ARCH=um" on the command
# line overrides the setting of ARCH below.  If a native build is happening,
# then ARCH is assigned, getting whatever value it gets normally, and
# SUBARCH is subsequently ignored.

ifneq ($(CROSS_COMPILE),)
SUBARCH := $(shell echo $(CROSS_COMPILE) | cut -d- -f1)
else
SUBARCH := $(shell uname -m)
endif
SUBARCH := $(shell echo $(SUBARCH) | sed -e s/i.86/i386/ -e s/sun4u/sparc64/ \
					 -e s/arm.*/arm/ -e s/sa110/arm/ \
					 -e s/s390x/s390/ -e s/parisc64/parisc/ \
					 -e s/ppc.*/powerpc/ -e s/mips.*/mips/ )

ARCH ?= $(SUBARCH)

# Architecture as present in compile.h
UTS_MACHINE := $(ARCH)

# SHELL used by kbuild
CONFIG_SHELL := $(shell if [ -x "$$BASH" ]; then echo $$BASH; \
	  else if [ -x /bin/bash ]; then echo /bin/bash; \
	  else echo sh; fi ; fi)

# 	Decide whether to build built-in, modular, or both.
#	Normally, just do built-in.

KBUILD_MODULES :=
KBUILD_BUILTIN := 1

#	If we have only "make modules", don't compile built-in objects.
#	When we're building modules with modversions, we need to consider
#	the built-in objects during the descend as well, in order to
#	make sure the checksums are uptodate before we record them.

ifeq ($(MAKECMDGOALS),modules)
  KBUILD_BUILTIN := $(if $(CONFIG_MODVERSIONS),1)
endif

#	If we have "make <whatever> modules", compile modules
#	in addition to whatever we do anyway.
#	Just "make" or "make all" shall build modules as well

ifneq ($(filter all _all modules,$(MAKECMDGOALS)),)
  KBUILD_MODULES := 1
endif

ifeq ($(MAKECMDGOALS),)
  KBUILD_MODULES := 1
endif

export KBUILD_MODULES KBUILD_BUILTIN
export KBUILD_CHECKSRC KBUILD_SRC KBUILD_EXTMOD

# Beautify output
# ---------------------------------------------------------------------------
#
# Normally, we echo the whole command before executing it. By making
# that echo $($(quiet)$(cmd)), we now have the possibility to set
# $(quiet) to choose other forms of output instead, e.g.
#
#         quiet_cmd_cc_o_c = Compiling $(RELDIR)/$@
#         cmd_cc_o_c       = $(CC) $(c_flags) -c -o $@ $<
#
# If $(quiet) is empty, the whole command will be printed.
# If it is set to "quiet_", only the short version will be printed.
# If it is set to "silent_", nothing wil be printed at all, since
# the variable $(silent_cmd_cc_o_c) doesn't exist.
#
# A simple variant is to prefix commands with $(Q) - that's useful
# for commands that shall be hidden in non-verbose mode.
#
#	$(Q)ln $@ :<
#
# If KBUILD_VERBOSE equals 0 then the above command will be hidden.
# If KBUILD_VERBOSE equals 1 then the above command is displayed.

ifeq ($(KBUILD_VERBOSE),1)
  quiet =
  Q =
else
  quiet=quiet_
  Q = @
endif

# If the user is running make -s (silent mode), suppress echoing of
# commands

ifneq ($(findstring s,$(MAKEFLAGS)),)
  quiet=silent_
endif

export quiet Q KBUILD_VERBOSE


# Look for make include files relative to root of kernel src
MAKEFLAGS += --include-dir=$(srctree)

HOSTCC  	= gcc
HOSTCXX  	= g++
HOSTCFLAGS	:=
HOSTCXXFLAGS	:=
# We need some generic definitions
include $(srctree)/scripts/Kbuild.include

HOSTCFLAGS	+= $(call hostcc-option,-Wall -Wstrict-prototypes -O2 -fomit-frame-pointer,)
HOSTCXXFLAGS	+= -O2

# For maximum performance (+ possibly random breakage, uncomment
# the following)

MAKEFLAGS += -rR

# Make variables (CC, etc...)

AS		= $(CROSS_COMPILE)as
CC		= $(CROSS_COMPILE)gcc
LD		= $(CC) -nostdlib
CPP		= $(CC) -E
AR		= $(CROSS_COMPILE)ar
NM		= $(CROSS_COMPILE)nm
STRIP		= $(CROSS_COMPILE)strip
OBJCOPY		= $(CROSS_COMPILE)objcopy
OBJDUMP		= $(CROSS_COMPILE)objdump
PKG_CONFIG	?= $(CROSS_COMPILE)pkg-config
AWK		= awk
GENKSYMS	= scripts/genksyms/genksyms
DEPMOD		= /sbin/depmod
KALLSYMS	= scripts/kallsyms
PERL		= perl
CHECK		= sparse

CHECKFLAGS     := -D__linux__ -Dlinux -D__STDC__ -Dunix -D__unix__ -Wbitwise $(CF)
MODFLAGS	= -DMODULE
CFLAGS_MODULE   = $(MODFLAGS)
AFLAGS_MODULE   = $(MODFLAGS)
LDFLAGS_MODULE  = -r
CFLAGS_KERNEL	=
AFLAGS_KERNEL	=


# Use LINUXINCLUDE when you must reference the include/ directory.
# Needed to be compatible with the O= option
CFLAGS		:= $(CFLAGS)
# Added only to final link stage of busybox binary
CFLAGS_busybox	:= $(CFLAGS_busybox)
CPPFLAGS	:= $(CPPFLAGS)
AFLAGS		:= $(AFLAGS)
LDFLAGS		:= $(LDFLAGS)
LDLIBS		:=

# Read KERNELRELEASE from .kernelrelease (if it exists)
KERNELRELEASE = $(shell cat .kernelrelease 2> /dev/null)
KERNELVERSION = $(VERSION).$(PATCHLEVEL).$(SUBLEVEL)$(EXTRAVERSION)

export	VERSION PATCHLEVEL SUBLEVEL KERNELRELEASE KERNELVERSION \
	ARCH CONFIG_SHELL HOSTCC HOSTCFLAGS CROSS_COMPILE AS LD CC \
	CPP AR NM STRIP OBJCOPY OBJDUMP MAKE AWK GENKSYMS PERL UTS_MACHINE \
	HOSTCXX HOSTCXXFLAGS LDFLAGS_MODULE CHECK CHECKFLAGS

export CPPFLAGS NOSTDINC_FLAGS LINUXINCLUDE OBJCOPYFLAGS LDFLAGS
export CFLAGS CFLAGS_KERNEL CFLAGS_MODULE
export AFLAGS AFLAGS_KERNEL AFLAGS_MODULE
export FLTFLAGS

# When compiling out-of-tree modules, put MODVERDIR in the module
# tree rather than in the kernel tree. The kernel tree might
# even be read-only.
export MODVERDIR := $(if $(KBUILD_EXTMOD),$(firstword $(KBUILD_EXTMOD))/).tmp_versions

# Files to ignore in find ... statements

RCS_FIND_IGNORE := \( -name SCCS -o -name BitKeeper -o -name .svn -o -name CVS -o -name .pc -o -name .hg -o -name .git \) -prune -o
export RCS_TAR_IGNORE := --exclude SCCS --exclude BitKeeper --exclude .svn --exclude CVS --exclude .pc --exclude .hg --exclude .git

# ===========================================================================
# Rules shared between *config targets and build targets

# Basic helpers built in scripts/
PHONY += scripts_basic
scripts_basic:
	$(Q)$(MAKE) $(build)=scripts/basic

# To avoid any implicit rule to kick in, define an empty command.
scripts/basic/%: scripts_basic ;

# This target generates Kbuild's and Config.in's from *.c files
PHONY += gen_build_files
gen_build_files: $(wildcard $(srctree)/*/*.c) $(wildcard $(srctree)/*/*/*.c)
	$(Q)$(srctree)/scripts/gen_build_files.sh $(srctree) $(objtree)

# bbox: we have helpers in applets/
# we depend on scripts_basic, since scripts/basic/fixdep
# must be built before any other host prog
PHONY += applets_dir
applets_dir: scripts_basic gen_build_files
	$(Q)$(MAKE) $(build)=applets

applets/%: applets_dir ;

PHONY += outputmakefile
# outputmakefile generates a Makefile in the output directory, if using a
# separate output directory. This allows convenient use of make in the
# output directory.
outputmakefile:

=== contrib/libosmocore/debian/changelog ===
libosmocore (0.8.1+git2) UNRELEASED; urgency=medium

  * Add endian header
  * GPRS flow control changes
  * Add APN format routines to libosmocore.

 -- Holger Hans Peter Freyther <holger@moiji-mobile.com>  Thu, 16 Apr 2015 21:23:24 +0200

libosmocore (0.8.0) unstable; urgency=medium

  * New upstream release of libosmocore.

 -- Holger Hans Peter Freyther <holger@freyther.de>  Sun, 18 Jan 2015 19:04:10 +0100

libosmocore (0.7.0) unstable; urgency=medium

  * New upstream release of libosmocore.

 -- Harald Welte <laforge@gnumonks.org>  Thu, 21 Aug 2014 15:52:00 +0200

libosmocore (0.6.6) UNRELEASED; urgency=medium

  * New upstream release of libosmocore.

 -- Holger Hans Peter Freyther <holger@freyther.de>  Mon, 31 Mar 2014 15:37:33 +0200

libosmocore (0.6.5) unstable; urgency=medium

  * New upstream release of libosmocore

 -- Holger Hans Peter Freyther <holger@freyther.de>  Mon, 20 Jan 2014 10:37:23 +0100

libosmocore (0.6.4+git3) unstable; urgency=low

  * GPRS fix NS connections to a SGSN when configured via VTY

 -- Jacob Erlbeck <jerlbeck@sysmocom.de>  Thu, 07 Nov 2013 16:07:20 +0100

libosmocore (0.6.4+git2) unstable; urgency=low

  * GPRS related changes, some GSM encoding/decoding changes
  * GPRS correctly determine routable NSVC.
  * Update with GPRS changes

 -- Holger Hans Peter Freyther <holger@freyther.de>  Thu, 10 Oct 2013 14:16:37 +0200

libosmocore (0.6.3+git1-1) unstable; urgency=low

  * New upstream release with new primitives, USSD fixes.
  * Split libosmocore into several package. One lib per package.

 -- Holger Hans Peter Freyther <holger@freyther.de>  Fri, 09 Aug 2013 17:47:30 +0200

libosmocore (0.6.2) unstable; urgency=low

  * New upstream release with NS UDP DSCP ABI changes

 -- Holger Hans Peter Freyther <holger@freyther.de>  Wed, 26 Jun 2013 08:01:55 +0200

libosmocore (0.5.3+git1-6) unstable; urgency=low

  * Build new package with the new API required for osmo-bts/openbsc
  * Package the arfcn utility.
  * Add the SOCK_RAW work-around for glibc.
  * Re-enable the debug packages thanks to Jan.

 -- Holger Hans Peter Freyther <holger@freyther.de>  Fri, 04 Jan 2013 09:54:55 +0100

libosmocore (0.5.3+git1-2) unstable; urgency=low

  * New upstream version 

 -- Holger Hans Peter Freyther <holger@freyther.de>  Mon, 05 Nov 2012 21:35:57 +0100

libosmocore (0.5.3+git1-1) precise; urgency=low

  * Fix issue with package version.

 -- Eric Butler <eric@codebutler.com>  Tue, 14 Aug 2012 20:43:17 -0700

libosmocore (0.5.3+git1) precise; urgency=low

  * Updated debian package.

 -- Eric Butler <eric@codebutler.com>  Tue, 14 Aug 2012 16:53:56 -0700

libosmocore (0.3.0) natty; urgency=low

  * New upstream version of libosmocore

 -- Harald Welte <laforge@gnumonks.org>  Tue, 10 May 2011 17:28:24 +0200

libosmocore (0.1.27) natty; urgency=low

  * New upstream version of libosmocore.

 -- Holger Hans Peter Freyther <holger@freyther.de>  Thu, 13 Jan 2011 18:07:36 +0800

libosmocore (0.1.17-1) unstable; urgency=low

  * Initial release

 -- Harald Welte <laforge@gnumonks.org>  Tue, 24 Aug 2010 10:55:04 +0200

=== contrib/libosmocore/debian/control ===
Source: libosmocore
Section: libs
Priority: optional
Maintainer: Harald Welte <laforge@gnumonks.org>
Build-Depends: debhelper (>= 9), autotools-dev, autoconf, automake, libtool, dh-autoreconf, libdpkg-perl, git, doxygen, libpcsclite-dev, pkg-config
Standards-Version: 3.9.6
Homepage: http://bb.osmocom.org/trac/wiki/libosmocore
Vcs-Git: git://git.osmocom.org/libosmocore.git
Vcs-Browser: http://git.osmocom.org/gitweb?p=libosmocore.git;a=summary

Package: libosmocore
Section: libs
Architecture: any
Depends: libosmocodec0, libosmocore6, libosmogb3, libosmogsm5, libosmovty1, ${misc:Depends}
Multi-Arch: foreign
Description: Open Source MObile COMmunications CORE library

Package: libosmocodec0
Section: libs
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Multi-Arch: same
Description: Osmo codec library

Package: libosmocore6
Section: libs
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Multi-Arch: same
Description: Osmo Core library

Package: libosmogb3
Section: libs
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Multi-Arch: same
Description: Osmo GPRS GB library

Package: libosmogsm5
Section: libs
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Multi-Arch: same
Description: Osmo GSM utility library

Package: libosmovty1
Section: libs
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Multi-Arch: same
Description: Osmo VTY library

Package: libosmoctrl0
Section: libs
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Multi-Arch: same
Description: Osmo control library

Package: libosmosim0
Section: libs
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Multi-Arch: same
Description: Osmo SIM library

Package: libosmocore-dev
Section: libdevel
Architecture: any
Depends: ${misc:Depends}, libosmocore
Multi-Arch: same
Description: Development headers for Open Source MObile COMmunications CORE library

Package: libosmocore-utils
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, libosmocore
Multi-Arch: same
Description: Utilities for gsm

Package: libosmocore-dbg
Architecture: any
Section: debug
Priority: extra
Depends: libosmocore (= ${binary:Version}), ${misc:Depends}
Multi-Arch: same
Description: Debug symbols for Open Source MObile COMmunications CORE library
